/*jshint esversion: 6 */

var sidPortal = "https://wifi-staging.socialidnow.com/portals/cbt-ubnt-unifi-lab";

function getQueryParams(parameterName) {
  var result = null,
    tmp = [];
  var items = location.search.substr(1).split("&");

  for (var index = 0; index < items.length; index++) {
    tmp = items[index].split("=");
    if (tmp[0] === parameterName) result = decodeURIComponent(tmp[1]);
  }

  return result;
}

function serialize(params) {
  return Object.entries(params).
    filter(function([key, val]) { return val; }).
    map(function([key, val]) { return key + '=' + encodeURIComponent(val); }).
    join('&');
}

function buildLoginURL() {
  var params = {
    ap: getQueryParams("ap"),
    id: getQueryParams("id"),
    ssid: getQueryParams("ssid"),
    url: getQueryParams("url"),
    t: getQueryParams("t"),
    login_url: 'http://' + window.location.host + window.location.pathname + 'signin.html'
  };

  return sidPortal + "/auth?" + serialize(params);
}

function performRadiusLogin() {
  var data = JSON.parse(atob(getQueryParams("data")));
  var payload = {
    by: 'radius',
    username: data.username,
    password: data.password,
  };
  var redirect = sidPortal + "#/fail";
  var xhr = new XMLHttpRequest();

  xhr.open("POST", "login", true);
  xhr.setRequestHeader('Content-Type', 'application/json; charset=UTF-8');
  xhr.onload = function(e) {
    if (xhr.readyState === 4) {
      if (xhr.status === 200) {
        var resp = JSON.parse(xhr.responseText);
        if (resp.data.length > 0) {
          redirect = data.continue_url; //success
        }
        window.location = redirect;
      }
    }
  };

  try {
    var resp = xhr.send(JSON.stringify(payload));
  } catch (err) {
    window.location = redirect;
  }
}
